Attribute VB_Name = "mMain"
Option Explicit
Declare Function GetInstanceEx Lib "DirectCom" _
    (StrPtr_FName As Long, _
     StrPtr_ClassName As Long, _
     ByVal UseAlteredSearchPath As Boolean) As Object
     
Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" _
    (ByVal lpLibFileName As String) As Long
Public Declare Function FreeLibrary Lib "kernel32" _
    (ByVal hLibModule As Long) As Long

Public New_c As cConstructor
Public Cairo As cCairo

Sub Main()
Dim fMain As cfMain
Dim hLib As Long


  If App.LogMode = 0 Then
    Set New_c = New cConstructor
  Else
    hLib = LoadLibrary(App.Path & "\RC5\DirectCOM.dll")
    Set New_c = GetInstanceEx(StrPtr(App.Path & "\RC5\vbRichClient5.dll"), _
                StrPtr("cConstructor"), True)
  End If
  Set Cairo = New_c.Cairo
  
  FillImageList
  
  Set fMain = New cfMain
  fMain.Show
  
  Cairo.WidgetForms.EnterMessageLoop
  If hLib <> 0 Then
    On Error Resume Next
    FreeLibrary hLib
  End If

End Sub

Public Function New_w(ClassName As String) As Object
  If App.LogMode = 0 Then
    Set New_w = VBA.CreateObject( _
        "vbWidgets." & ClassName)
  Else
    Set New_w = New_c.RegFree.GetInstanceEx( _
        App.Path & "\RC5\vbWidgets.dll", ClassName)
  End If
End Function
